package javax.swing.text.html;

import java.lang.reflect.Method;
import java.beans.PropertyDescriptor;
import java.beans.BeanInfo;
import sun.reflect.misc.MethodUtil;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.text.AttributeSet;
import sun.reflect.misc.ReflectUtil;
import java.awt.Component;
import javax.swing.text.Element;
import javax.swing.text.ComponentView;

public class ObjectView extends ComponentView
{
    public ObjectView(Element elem) {
        super(elem);
    }
    
    @Override
    protected Component createComponent() {
        AttributeSet attributes = this.getElement().getAttributes();
        String s = (String)attributes.getAttribute(HTML.Attribute.CLASSID);
        try {
            ReflectUtil.checkPackageAccess(s);
            Object instance = Class.forName(s, true, Thread.currentThread().getContextClassLoader()).newInstance();
            if ((instance instanceof Component)) {
                Component component = (Component)instance;
                this.setParameters(component, attributes);
                return component;
            }
        }
        catch (Throwable t) {}
        return this.getUnloadableRepresentation();
    }
    
    Component getUnloadableRepresentation() {
        JLabel label = new JLabel("??");
        label.setForeground(Color.red);
        return label;
    }
    
    private void setParameters(Component obj, AttributeSet set) {
        Class<Object> class1 = obj.getClass();
        BeanInfo beanInfo;
        try {
            beanInfo = Introspector.getBeanInfo(class1);
        }
        catch (IntrospectionException obj2) {
            System.err.println("introspector failed, ex: " + obj2);
            return;
        }
        PropertyDescriptor[] propertyDescriptors = beanInfo.getPropertyDescriptors();
        for (int i = 0; i < propertyDescriptors.length; ++i) {
            Object attribute = set.getAttribute(propertyDescriptors[i].getName());
            if ((attribute instanceof String)) {
                String s = (String)attribute;
                Method writeMethod = propertyDescriptors[i].getWriteMethod();
                if (writeMethod == null) {
                    return;
                }
                if (writeMethod.getParameterTypes().length != 1) {
                    return;
                }
                Object[] params = { s };
                try {
                    MethodUtil.invoke(writeMethod, obj, params);
                }
                catch (Exception ex) {
                    System.err.println("Invocation failed");
                }
            }
        }
    }
}
